# (C) 2001-2021 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files from any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Intel Program License Subscription 
# Agreement, Intel FPGA IP License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Intel and sold by 
# Intel or its authorized distributors.  Please refer to the applicable 
# agreement for further details.


## ===================================================== 
##     Top level register map: Base Addresses
## ===================================================== 

########## GDR F-Tile ##########
## ================================================================== 
##     Ethernet registers Tx Stats Counters
## ================================================================== 
################ TX STATES ################
set  TX_REG_FRAGMENTS_LO       0x800
#set  REG_FRAGMENTS_HI       0x01
set  TX_REG_JABBERS_LO         0x808
#set  REG_JABBERS_HI         0x03
set  TX_REG_CRCERR_LO          0x810
#set  REG_CRCERR_SIZEOK_HI   0x05
set  TX_REG_CRCERR_SIZEOK_LO   0x818
#set  REG_CRCERR_HI          0x07
set  TX_REG_MCAST_DATA_ERR_LO  0x820
#set  REG_MCAST_DATA_ERR_HI  0x09
set  TX_REG_BCAST_DATA_ERR_LO  0x828
#set  REG_BCAST_DATA_ERR_HI  0x0B
set  TX_REG_UCAST_DATA_ERR_LO  0x830
#set  REG_UCAST_DATA_ERR_HI  0x0D
set  TX_REG_MCAST_CTRL_ERR_LO  0x838
#set  REG_MCAST_CTRL_ERR_HI  0x0F
set  TX_REG_BCAST_CTRL_ERR_LO  0x840
#set  REG_BCAST_CTRL_ERR_HI  0x11
set  TX_REG_UCAST_CTRL_ERR_LO  0x848
#set  REG_UCAST_CTRL_ERR_HI  0x13
set  TX_REG_PAUSE_ERR_LO       0x850
#set  REG_PAUSE_ERR_HI       0x15
set  TX_REG_64B_LO             0x858
set  TX_REG_64B_HI             0x85C
set  TX_REG_65to127B_LO        0x860
set  TX_REG_65to127B_HI        0x864
set  TX_REG_128to255B_LO       0x868
set  TX_REG_128to255B_HI       0x86C
set  TX_REG_256to511B_LO       0x870
set  TX_REG_256to511B_HI       0x874
set  TX_REG_512to1023B_LO      0x878
set  TX_REG_512to1023B_HI      0x87C
set  TX_REG_1024to1518B_LO     0x880
set  TX_REG_1024to1518B_HI     0x884
set  TX_REG_1519toMAXB_LO      0x888
set  TX_REG_1519toMAXB_HI      0x88C
set  TX_REG_OVERSIZE_LO        0x890
#set  REG_OVERSIZE_HI        0x25
set  TX_REG_MCAST_DATA_OK_LO   0x898
set  TX_REG_MCAST_DATA_OK_HI   0x89C
set  TX_REG_BCAST_DATA_OK_LO   0x8A0
set  TX_REG_BCAST_DATA_OK_HI   0x8A4
set  TX_REG_UCAST_DATA_OK_LO   0x8A8
set  TX_REG_UCAST_DATA_OK_HI   0x8AC
set  TX_REG_MCAST_CTRL_OK_LO   0x8B0
set  TX_REG_MCAST_CTRL_OK_HI   0x8B4
set  TX_REG_BCAST_CTRL_OK_LO   0x8B8
set  TX_REG_BCAST_CTRL_OK_HI   0x8BC
set  TX_REG_UCAST_CTRL_OK_LO   0x8C0
set  TX_REG_UCAST_CTRL_OK_HI   0x8C4
set  TX_REG_PAUSE_LO           0x8C8
set  TX_REG_PAUSE_HI           0x8CC
set  TX_REG_RNT_LO             0x8D0
#set  REG_RNT_HI            0x35
set  TX_REG_ST_LO              0x8D8
set  TX_REG_ST_HI              0x8DC
set  TX_REG_DB_LO              0x8E0
#set  REG_DB_HI             0x39
#set  REG_EBLK_HI           0x3A
set  TX_REG_EBLK_LO            0x8E8
set  TX_REG_FST_LO             0x8F0
set  TX_REG_FST_HI             0x8F4
#set  REG_F_LONG_HI         0x3E
#set  REG_F_LONG_LO         0x3F
set  TX_REG_STAT_CFG           0x274
#set  REG_STAT_STATUS       0x46
set TX_REG_PAYLOAD_OCT_OK_LO   0x8F8
set TX_REG_OCT_OK_LO           0x900 

 
########## GDR F-Tile ##########
################ RX STATES ################# 
set  RX_REG_FRAGMENTS_LO       0x934
#set  REG_FRAGMENTS_HI       0x01
set  RX_REG_JABBERS_LO         0x93C
#set  REG_JABBERS_HI         0x03
set  RX_REG_CRCERR_LO          0x944
#set  REG_CRCERR_SIZEOK_HI   0x05
set  RX_REG_CRCERR_SIZEOK_LO   0x94C
#set  REG_CRCERR_HI          0x07
set  RX_REG_MCAST_DATA_ERR_LO  0x954
#set  REG_MCAST_DATA_ERR_HI  0x09
set  RX_REG_BCAST_DATA_ERR_LO  0x95C
#set  REG_BCAST_DATA_ERR_HI  0x0B
set  RX_REG_UCAST_DATA_ERR_LO  0x964
#set  REG_UCAST_DATA_ERR_HI  0x0D
set  RX_REG_MCAST_CTRL_ERR_LO  0x96C
#set  REG_MCAST_CTRL_ERR_HI  0x0F
set  RX_REG_BCAST_CTRL_ERR_LO  0x974
#set  REG_BCAST_CTRL_ERR_HI  0x11
set  RX_REG_UCAST_CTRL_ERR_LO  0x97C
#set  REG_UCAST_CTRL_ERR_HI  0x13
set  RX_REG_PAUSE_ERR_LO       0x984
#set  REG_PAUSE_ERR_HI       0x15
set  RX_REG_64B_LO             0x98C
set  RX_REG_64B_HI             0x990
set  RX_REG_65to127B_LO        0x994
set  RX_REG_65to127B_HI        0x998
set  RX_REG_128to255B_LO       0x99C
set  RX_REG_128to255B_HI       0x9A0
set  RX_REG_256to511B_LO       0x9A4
set  RX_REG_256to511B_HI       0x9A8
set  RX_REG_512to1023B_LO      0x9AC
set  RX_REG_512to1023B_HI      0x9B0
set  RX_REG_1024to1518B_LO     0x9B4
set  RX_REG_1024to1518B_HI     0x9B8
set  RX_REG_1519toMAXB_LO      0x9BC
set  RX_REG_1519toMAXB_HI      0x9C0
set  RX_REG_OVERSIZE_LO        0x9C4
#set  REG_OVERSIZE_HI        0x25
set  RX_REG_MCAST_DATA_OK_LO   0x9CC
set  RX_REG_MCAST_DATA_OK_HI   0x9D0
set  RX_REG_BCAST_DATA_OK_LO   0x9D4
set  RX_REG_BCAST_DATA_OK_HI   0x9D8
set  RX_REG_UCAST_DATA_OK_LO   0x9DC
set  RX_REG_UCAST_DATA_OK_HI   0x9E0
set  RX_REG_MCAST_CTRL_OK_LO   0x9E4
set  RX_REG_MCAST_CTRL_OK_HI   0x9E8
set  RX_REG_BCAST_CTRL_OK_LO   0x9EC
set  RX_REG_BCAST_CTRL_OK_HI   0x9F0
set  RX_REG_UCAST_CTRL_OK_LO   0x9F4
set  RX_REG_UCAST_CTRL_OK_HI   0x9F8
set  RX_REG_PAUSE_LO           0x9FC
set  RX_REG_PAUSE_HI           0xA00
set  RX_REG_RNT_LO             0xA04
#set  REG_RNT_HI            0x35
set  RX_REG_ST_LO              0xA0C
set  RX_REG_ST_HI              0xA10
set  RX_REG_DB_LO              0xA14
#set  REG_DB_HI             0x39
#set  REG_EBLK_HI           0x3A
set  RX_REG_EBLK_LO            0xA1C
set  RX_REG_FST_LO             0xA24
set  RX_REG_FST_HI             0xA28
#set  REG_F_LONG_HI         0x3E
#set  REG_F_LONG_LO         0x3F
set  RX_REG_STAT_CFG           0x278
#set  REG_STAT_STATUS       0x46
set RX_REG_PAYLOAD_OCT_OK_LO   0xA2C
set RX_REG_OCT_OK_LO           0xA34 

set  TX_REG_STAT_REVID        0x40
set  TX_REG_STAT_SCRATCH      0x41
set  TX_REG_STAT_NAME_0       0x42
set  TX_REG_STAT_NAME_1       0x43
set  TX_REG_STAT_NAME_2       0x44


####################### GDR F-Tile #######################
proc chkmac_stats {{ip_inst_base_addr 0}} {
    global BASE_EHIPRegisters
    check_stats_rx [expr $ip_inst_base_addr + $BASE_EHIPRegisters] Rx
    check_stats_tx [expr $ip_inst_base_addr + $BASE_EHIPRegisters] Tx  
}

proc pause_stats_rx {reg_base} {
    global RX_REG_STAT_CFG
    reg_write $reg_base $RX_REG_STAT_CFG 0x4
}

proc unpause_stats_rx {reg_base} {
    global RX_REG_STAT_CFG
    reg_write $reg_base $RX_REG_STAT_CFG 0x0
}

proc pause_stats_tx {reg_base} {
    global TX_REG_STAT_CFG
    reg_write $reg_base $TX_REG_STAT_CFG 0x4
}

proc unpause_stats_tx {reg_base} {
    global TX_REG_STAT_CFG
    reg_write $reg_base $TX_REG_STAT_CFG 0x0
}

proc clear_stats_rx {reg_base} {
    global RX_REG_STAT_CFG
    reg_write $reg_base $RX_REG_STAT_CFG 0x1
    reg_write $reg_base $RX_REG_STAT_CFG 0x0
}

proc clear_stats_tx {reg_base} {
    global TX_REG_STAT_CFG
    reg_write $reg_base $TX_REG_STAT_CFG 0x1
    reg_write $reg_base $TX_REG_STAT_CFG 0x0
}

proc clear_all_stats {{ip_inst_base_addr 0}} {
    global BASE_EHIPRegisters
    clear_stats_rx [expr $ip_inst_base_addr + $BASE_EHIPRegisters]
    clear_stats_tx [expr $ip_inst_base_addr + $BASE_EHIPRegisters]
}

proc check_stats_rx {reg_base t} {
    global BASE_STATS
    global RX_REG_FRAGMENTS_LO    
    #global  REG_FRAGMENTS_HI      
    global RX_REG_JABBERS_LO      
    #global  REG_JABBERS_HI        
    global RX_REG_CRCERR_LO       
    #global  REG_CRCERR_SIZEOK_HI  
    global RX_REG_CRCERR_SIZEOK_LO
    #global  REG_CRCERR_HI         
    global RX_REG_MCAST_DATA_ERR_LO
    #global  REG_MCAST_DATA_ERR_HI 
    global RX_REG_BCAST_DATA_ERR_LO
    #global  REG_BCAST_DATA_ERR_HI 
    global RX_REG_UCAST_DATA_ERR_LO
    #global  REG_UCAST_DATA_ERR_HI 
    global RX_REG_MCAST_CTRL_ERR_LO
    #global  REG_MCAST_CTRL_ERR_HI 
    global RX_REG_BCAST_CTRL_ERR_LO
    #global  REG_BCAST_CTRL_ERR_HI 
    global RX_REG_UCAST_CTRL_ERR_LO
    #global  REG_UCAST_CTRL_ERR_HI 
    global RX_REG_PAUSE_ERR_LO    
    #global  REG_PAUSE_ERR_HI      
    global RX_REG_64B_LO          
    global RX_REG_64B_HI          
    global RX_REG_65to127B_LO     
    global RX_REG_65to127B_HI     
    global RX_REG_128to255B_LO    
    global RX_REG_128to255B_HI    
    global RX_REG_256to511B_LO    
    global RX_REG_256to511B_HI    
    global RX_REG_512to1023B_LO   
    global RX_REG_512to1023B_HI   
    global RX_REG_1024to1518B_LO  
    global RX_REG_1024to1518B_HI  
    global RX_REG_1519toMAXB_LO   
    global RX_REG_1519toMAXB_HI   
    global RX_REG_OVERSIZE_LO     
    #global  REG_OVERSIZE_HI       
    global RX_REG_MCAST_DATA_OK_LO
    global RX_REG_MCAST_DATA_OK_HI
    global RX_REG_BCAST_DATA_OK_LO
    global RX_REG_BCAST_DATA_OK_HI
    global RX_REG_UCAST_DATA_OK_LO
    global RX_REG_UCAST_DATA_OK_HI
    global RX_REG_MCAST_CTRL_OK_LO
    global RX_REG_MCAST_CTRL_OK_HI
    global RX_REG_BCAST_CTRL_OK_LO
    global RX_REG_BCAST_CTRL_OK_HI
    global RX_REG_UCAST_CTRL_OK_LO
    global RX_REG_UCAST_CTRL_OK_HI
    global RX_REG_PAUSE_LO        
    global RX_REG_PAUSE_HI        
    global RX_REG_RNT_LO          
    #global  REG_RNT_HI            
    global RX_REG_ST_LO           
    global RX_REG_ST_HI           
    global RX_REG_DB_LO           
    #global  REG_DB_HI             
    #global  REG_EBLK_HI           
    global RX_REG_EBLK_LO         
    global RX_REG_FST_LO          
    global RX_REG_FST_HI          
    #global  REG_F_LONG_HI         
    #global  REG_F_LONG_LO         
    global RX_REG_STAT_CFG        
    #global  REG_STAT_STATUS  
    global RX_REG_PAYLOAD_OCT_OK_LO   
    global RX_REG_OCT_OK_LO            

    set BASE_STATS $reg_base
    #for CLI output only
    #for table widths
    set w_des 30
    set w_val 30
    pause_stats_rx $reg_base
    puts " =========================================================================================="
    puts "                        STATISTICS FOR BASE $BASE_STATS ($t)                               "
    puts " =========================================================================================="
    puts "Fragmented Frames                : [expr [stats_read $BASE_STATS     $RX_REG_FRAGMENTS_LO        ]] "
    puts "Jabbered Frames                  : [expr [stats_read $BASE_STATS     $RX_REG_JABBERS_LO          ]] "
    puts "Any Size with FCS Err Frame      : [expr [stats_read $BASE_STATS     $RX_REG_CRCERR_LO           ]] "
    puts "Right Size with FCS Err Fra      : [expr [stats_read $BASE_STATS     $RX_REG_CRCERR_SIZEOK_LO    ]] "
    puts "Multicast data  Err Frames       : [expr [stats_read $BASE_STATS     $RX_REG_MCAST_DATA_ERR_LO   ]] "
    puts "Broadcast data Err  Frames       : [expr [stats_read $BASE_STATS     $RX_REG_BCAST_DATA_ERR_LO   ]] "
    puts "Unicast data Err  Frames         : [expr [stats_read $BASE_STATS     $RX_REG_UCAST_DATA_ERR_LO   ]] "
    puts "Multicast control  Err Frame     : [expr [stats_read $BASE_STATS     $RX_REG_MCAST_CTRL_ERR_LO   ]] "
    puts "Broadcast control Err  Frame     : [expr [stats_read $BASE_STATS     $RX_REG_BCAST_CTRL_ERR_LO   ]] "
    puts "Unicast control Err  Frames      : [expr [stats_read $BASE_STATS     $RX_REG_UCAST_CTRL_ERR_LO   ]] "
    puts "Pause control Err  Frames        : [expr [stats_read $BASE_STATS     $RX_REG_PAUSE_ERR_LO        ]] "

    puts "64 Byte Frames                   : [expr [stats_read $BASE_STATS     $RX_REG_64B_LO              ]] "
    puts "65 - 127 Byte Frames             : [expr [stats_read $BASE_STATS     $RX_REG_65to127B_LO         ]] "
    puts "128 - 255 Byte Frames            : [expr [stats_read $BASE_STATS     $RX_REG_128to255B_LO        ]] "
    puts "256 - 511 Byte Frames            : [expr [stats_read $BASE_STATS     $RX_REG_256to511B_LO        ]] "
    puts "512 - 1023 Byte Frames           : [expr [stats_read $BASE_STATS     $RX_REG_512to1023B_LO       ]] "
    puts "1024 - 1518 Byte Frames          : [expr [stats_read $BASE_STATS     $RX_REG_1024to1518B_LO      ]] "
    puts "1519 - MAX Byte Frames           : [expr [stats_read $BASE_STATS     $RX_REG_1519toMAXB_LO       ]] "
    puts "> MAX Byte Frames                : [expr [stats_read $BASE_STATS     $RX_REG_OVERSIZE_LO         ]] "
    puts "$t Frame Starts                  : [expr [stats_read $BASE_STATS     $RX_REG_ST_LO               ]] "
    puts "Multicast data  OK  Frame        : [expr [stats_read $BASE_STATS     $RX_REG_MCAST_DATA_OK_LO    ]] "
    puts "Broadcast data OK   Frame        : [expr [stats_read $BASE_STATS     $RX_REG_BCAST_DATA_OK_LO    ]] "
    puts "Unicast data OK   Frames         : [expr [stats_read $BASE_STATS     $RX_REG_UCAST_DATA_OK_LO    ]] "
    puts "Multicast Control Frames         : [expr [stats_read $BASE_STATS     $RX_REG_MCAST_CTRL_OK_LO    ]] "
    puts "Broadcast Control Frames         : [expr [stats_read $BASE_STATS     $RX_REG_BCAST_CTRL_OK_LO    ]] "
    puts "Unicast Control Frames           : [expr [stats_read $BASE_STATS     $RX_REG_UCAST_CTRL_OK_LO    ]] "
    puts "Pause Control Frames             : [expr [stats_read $BASE_STATS     $RX_REG_PAUSE_LO            ]] "
    puts "Data and padding octets          : [expr [stats_read $BASE_STATS     $RX_REG_PAYLOAD_OCT_OK_LO   ]] "
    puts "Frame octets                     : [expr [stats_read $BASE_STATS     $RX_REG_OCT_OK_LO           ]] "
    unpause_stats_rx $reg_base
}

proc check_stats_tx {reg_base t} {
    global BASE_STATS
    global TX_REG_FRAGMENTS_LO    
    #global  REG_FRAGMENTS_HI      
    global TX_REG_JABBERS_LO      
    #global  REG_JABBERS_HI        
    global TX_REG_CRCERR_LO       
    #global  REG_CRCERR_SIZEOK_HI  
    global TX_REG_CRCERR_SIZEOK_LO
    #global  REG_CRCERR_HI         
    global TX_REG_MCAST_DATA_ERR_LO
    #global  REG_MCAST_DATA_ERR_HI 
    global TX_REG_BCAST_DATA_ERR_LO
    #global  REG_BCAST_DATA_ERR_HI 
    global TX_REG_UCAST_DATA_ERR_LO
    #global  REG_UCAST_DATA_ERR_HI 
    global TX_REG_MCAST_CTRL_ERR_LO
    #global  REG_MCAST_CTRL_ERR_HI 
    global TX_REG_BCAST_CTRL_ERR_LO
    #global  REG_BCAST_CTRL_ERR_HI 
    global TX_REG_UCAST_CTRL_ERR_LO
    #global  REG_UCAST_CTRL_ERR_HI 
    global TX_REG_PAUSE_ERR_LO    
    #global  REG_PAUSE_ERR_HI      
    global TX_REG_64B_LO          
    global TX_REG_64B_HI          
    global TX_REG_65to127B_LO     
    global TX_REG_65to127B_HI     
    global TX_REG_128to255B_LO    
    global TX_REG_128to255B_HI    
    global TX_REG_256to511B_LO    
    global TX_REG_256to511B_HI    
    global TX_REG_512to1023B_LO   
    global TX_REG_512to1023B_HI   
    global TX_REG_1024to1518B_LO  
    global TX_REG_1024to1518B_HI  
    global TX_REG_1519toMAXB_LO   
    global TX_REG_1519toMAXB_HI   
    global TX_REG_OVERSIZE_LO     
    #global  REG_OVERSIZE_HI       
    global TX_REG_MCAST_DATA_OK_LO
    global TX_REG_MCAST_DATA_OK_HI
    global TX_REG_BCAST_DATA_OK_LO
    global TX_REG_BCAST_DATA_OK_HI
    global TX_REG_UCAST_DATA_OK_LO
    global TX_REG_UCAST_DATA_OK_HI
    global TX_REG_MCAST_CTRL_OK_LO
    global TX_REG_MCAST_CTRL_OK_HI
    global TX_REG_BCAST_CTRL_OK_LO
    global TX_REG_BCAST_CTRL_OK_HI
    global TX_REG_UCAST_CTRL_OK_LO
    global TX_REG_UCAST_CTRL_OK_HI
    global TX_REG_PAUSE_LO        
    global TX_REG_PAUSE_HI        
    global TX_REG_RNT_LO          
    #global  REG_RNT_HI            
    global TX_REG_ST_LO           
    global TX_REG_ST_HI           
    global TX_REG_DB_LO           
    #global  REG_DB_HI             
    #global  REG_EBLK_HI           
    global TX_REG_EBLK_LO         
    global TX_REG_FST_LO          
    global TX_REG_FST_HI          
    #global  REG_F_LONG_HI         
    #global  REG_F_LONG_LO         
    global TX_REG_STAT_CFG        
    #global  REG_STAT_STATUS        
    global TX_REG_PAYLOAD_OCT_OK_LO   
    global TX_REG_OCT_OK_LO

    set BASE_STATS $reg_base
    #for CLI output only
    #for table widths
    set w_des 30
    set w_val 30
    pause_stats_tx $reg_base
    puts " =========================================================================================="
    puts "                        STATISTICS FOR BASE $BASE_STATS ($t)                               "
    puts " =========================================================================================="
    puts "Fragmented Frames                : [expr [stats_read $BASE_STATS     $TX_REG_FRAGMENTS_LO        ]] "
    puts "Jabbered Frames                  : [expr [stats_read $BASE_STATS     $TX_REG_JABBERS_LO          ]] "
    puts "Any Size with FCS Err Frame      : [expr [stats_read $BASE_STATS     $TX_REG_CRCERR_LO           ]] "
    puts "Right Size with FCS Err Fra      : [expr [stats_read $BASE_STATS     $TX_REG_CRCERR_SIZEOK_LO    ]] "
    puts "Multicast data  Err Frames       : [expr [stats_read $BASE_STATS     $TX_REG_MCAST_DATA_ERR_LO   ]] "
    puts "Broadcast data Err  Frames       : [expr [stats_read $BASE_STATS     $TX_REG_BCAST_DATA_ERR_LO   ]] "
    puts "Unicast data Err  Frames         : [expr [stats_read $BASE_STATS     $TX_REG_UCAST_DATA_ERR_LO   ]] "
    puts "Multicast control  Err Frame     : [expr [stats_read $BASE_STATS     $TX_REG_MCAST_CTRL_ERR_LO   ]] "
    puts "Broadcast control Err  Frame     : [expr [stats_read $BASE_STATS     $TX_REG_BCAST_CTRL_ERR_LO   ]] "
    puts "Unicast control Err  Frames      : [expr [stats_read $BASE_STATS     $TX_REG_UCAST_CTRL_ERR_LO   ]] "
    puts "Pause control Err  Frames        : [expr [stats_read $BASE_STATS     $TX_REG_PAUSE_ERR_LO        ]] "

    puts "64 Byte Frames                   : [expr [stats_read $BASE_STATS     $TX_REG_64B_LO              ]] "
    puts "65 - 127 Byte Frames             : [expr [stats_read $BASE_STATS     $TX_REG_65to127B_LO         ]] "
    puts "128 - 255 Byte Frames            : [expr [stats_read $BASE_STATS     $TX_REG_128to255B_LO        ]] "
    puts "256 - 511 Byte Frames            : [expr [stats_read $BASE_STATS     $TX_REG_256to511B_LO        ]] "
    puts "512 - 1023 Byte Frames           : [expr [stats_read $BASE_STATS     $TX_REG_512to1023B_LO       ]] "
    puts "1024 - 1518 Byte Frames          : [expr [stats_read $BASE_STATS     $TX_REG_1024to1518B_LO      ]] "
    puts "1519 - MAX Byte Frames           : [expr [stats_read $BASE_STATS     $TX_REG_1519toMAXB_LO       ]] "
    puts "> MAX Byte Frames                : [expr [stats_read $BASE_STATS     $TX_REG_OVERSIZE_LO         ]] "
    puts "$t Frame Starts                  : [expr [stats_read $BASE_STATS     $TX_REG_ST_LO               ]] "
    puts "Multicast data  OK  Frame        : [expr [stats_read $BASE_STATS     $TX_REG_MCAST_DATA_OK_LO    ]] "
    puts "Broadcast data OK   Frame        : [expr [stats_read $BASE_STATS     $TX_REG_BCAST_DATA_OK_LO    ]] "
    puts "Unicast data OK   Frames         : [expr [stats_read $BASE_STATS     $TX_REG_UCAST_DATA_OK_LO    ]] "
    puts "Multicast Control Frames         : [expr [stats_read $BASE_STATS     $TX_REG_MCAST_CTRL_OK_LO    ]] "
    puts "Broadcast Control Frames         : [expr [stats_read $BASE_STATS     $TX_REG_BCAST_CTRL_OK_LO    ]] "
    puts "Unicast Control Frames           : [expr [stats_read $BASE_STATS     $TX_REG_UCAST_CTRL_OK_LO    ]] "
    puts "Pause Control Frames             : [expr [stats_read $BASE_STATS     $TX_REG_PAUSE_LO            ]] "
    puts "Data and padding octets          : [expr [stats_read $BASE_STATS     $TX_REG_PAYLOAD_OCT_OK_LO   ]] "
    puts "Frame octets                     : [expr [stats_read $BASE_STATS     $TX_REG_OCT_OK_LO           ]] "
    unpause_stats_tx $reg_base
}
############################## GDR F-Tile edits done ##################################
  


proc pause_stats {reg_base} {
    global REG_STAT_CFG
    reg_write $reg_base $REG_STAT_CFG 0x4
}

proc unpause_stats {reg_base} {
    global REG_STAT_CFG
    reg_write $reg_base $REG_STAT_CFG 0x0
}


proc diff_count { info_offset {device 0} } {
    global BASE_TXSTATS
    global BASE_RXSTATS
    global BASE_NDEVICE

    set tx_value [expr [stats_read [expr ($BASE_NDEVICE * $device) + $BASE_TXSTATS] $info_offset]]
    set rx_value [expr [stats_read [expr ($BASE_NDEVICE * $device) + $BASE_RXSTATS] $info_offset]]

    return [expr {$tx_value - $rx_value}]
}

proc check_packet_errors {{device 0}} {
    global BASE_RXSTATS
    global REG_FRAGMENTS_LO
    global REG_JABBERS_LO
    global REG_CRCERR_LO
    global REG_CRCERR_SIZEOK_LO
    global REG_MCAST_DATA_ERR_LO
    global REG_BCAST_DATA_ERR_LO
    global REG_UCAST_DATA_ERR_LO
    global REG_MCAST_CTRL_ERR_LO
    global REG_BCAST_CTRL_ERR_LO
    global REG_UCAST_CTRL_ERR_LO
    global REG_PAUSE_ERR_LO
    global BASE_NDEVICE 

    set BASE_STATS [expr ($BASE_NDEVICE * $device) + $BASE_RXSTATS]

    set frag_count      [expr [stats_read $BASE_STATS     $REG_FRAGMENTS_LO         ]]
    set jab_count       [expr [stats_read $BASE_STATS     $REG_JABBERS_LO           ]]
    set crcerr_count    [expr [stats_read $BASE_STATS     $REG_CRCERR_LO            ]]
    set crcerr2_count   [expr [stats_read $BASE_STATS     $REG_CRCERR_SIZEOK_LO     ]]
    set mcastderr_count [expr [stats_read $BASE_STATS     $REG_MCAST_DATA_ERR_LO    ]]
    set bcastderr_count [expr [stats_read $BASE_STATS     $REG_BCAST_DATA_ERR_LO    ]]
    set ucastderr_count [expr [stats_read $BASE_STATS     $REG_UCAST_DATA_ERR_LO    ]]
    set mcastcerr_count [expr [stats_read $BASE_STATS     $REG_MCAST_CTRL_ERR_LO    ]]
    set bcastcerr_count [expr [stats_read $BASE_STATS     $REG_BCAST_CTRL_ERR_LO    ]]
    set ucastcerr_count [expr [stats_read $BASE_STATS     $REG_UCAST_CTRL_ERR_LO    ]]
    set pauseerr_count  [expr [stats_read $BASE_STATS     $REG_PAUSE_ERR_LO         ]]

    set total [expr { $frag_count + $jab_count + $crcerr_count + $crcerr2_count \
        + $mcastderr_count + $bcastderr_count + $ucastderr_count \
        + $mcastcerr_count + $bcastcerr_count + $ucastcerr_count \
        + $pauseerr_count }]

    if {$total != 0} {
        puts "Error: Frame errors reported."
    }
    return $total
}

proc get_rx_count {{device 0}} {
    global BASE_RXSTATS
    global REG_ST_LO
    global BASE_NDEVICE
    set rx_value [expr [stats_read [expr ($BASE_NDEVICE * $device) + $BASE_RXSTATS] $REG_ST_LO]]
    return $rx_value
}

proc get_tx_count {{device 0}} {
    global BASE_TXSTATS
    global REG_ST_LO
    global BASE_NDEVICE
    set tx_value [expr [stats_read [expr ($BASE_NDEVICE * $device) + $BASE_TXSTATS] $REG_ST_LO]]
    return $tx_value
}

proc get_mac_rx_count_bin { size {device 0}} {
    global BASE_RXSTATS
    global BASE_NDEVICE
    set counter_reg [get_mac_count_register $size]
    set count [expr [stats_read [expr ($BASE_NDEVICE * $device) + $BASE_RXSTATS] $counter_reg]]
    return $count
}

proc get_mac_tx_count_bin { size {device 0}} {
    global BASE_TXSTATS
    global BASE_NDEVICE
    set counter_reg [get_mac_count_register $size]
    set count [expr [stats_read [expr ($BASE_NDEVICE * $device) + $BASE_TXSTATS] $counter_reg]]
    return $count
}

proc get_mac_count_register { size } {
    global REG_64B_LO
    global REG_65to127B_LO
    global REG_128to255B_LO
    global REG_256to511B_LO
    global REG_512to1023B_LO
    global REG_1024to1518B_LO
    global REG_1519toMAXB_LO
    global REG_OVERSIZE_LO

    if {$size <= 64} {
        return $REG_64B_LO
    } elseif {$size <= 127} {
        return $REG_65to127B_LO
    } elseif {$size <= 255} {
        return $REG_128to255B_LO
    } elseif {$size <= 511} {
        return $REG_256to511B_LO
    } elseif {$size <= 1023} {
        return $REG_512to1023B_LO
    } elseif {$size <= 1518} {
        return $REG_1024to1518B_LO
    } elseif {$size <= 9600} {
        return $REG_1519toMAXB_LO
    } else {
        return $REG_OVERSIZE_LO
    }
}

proc verify_rxtx_counts {{device 0}} {
    global REG_64B_LO
    global REG_65to127B_LO
    global REG_128to255B_LO
    global REG_256to511B_LO
    global REG_512to1023B_LO
    global REG_1024to1518B_LO
    global REG_1519toMAXB_LO
    global REG_OVERSIZE_LO
    global REG_ST_LO
    global REG_MCAST_DATA_OK_LO
    global REG_BCAST_DATA_OK_LO
    global REG_UCAST_DATA_OK_LO
    global REG_MCAST_CTRL_OK_LO
    global REG_BCAST_CTRL_OK_LO
    global REG_UCAST_CTRL_OK_LO
    global REG_PAUSE_LO

    set 64b_count [diff_count $REG_64B_LO $device]
    set 50b_count [diff_count $REG_65to127B_LO $device]
    set 128b_count [diff_count $REG_128to255B_LO $device]
    set 256b_count [diff_count $REG_256to511B_LO $device]
    set 512b_count [diff_count $REG_512to1023B_LO $device]
    set 1024b_count [diff_count $REG_1024to1518B_LO $device]
    set 1519_count [diff_count $REG_1519toMAXB_LO $device]
    set oversize_count [diff_count $REG_OVERSIZE_LO $device]
    set starts_count [diff_count $REG_ST_LO $device]
    set mcastd_count [diff_count $REG_MCAST_DATA_OK_LO $device]
    set bcastd_count [diff_count $REG_BCAST_DATA_OK_LO $device]
    set ucastd_count [diff_count $REG_UCAST_DATA_OK_LO $device]
    set mcastc_count [diff_count $REG_MCAST_CTRL_OK_LO $device]
    set bcastc_count [diff_count $REG_BCAST_CTRL_OK_LO $device]
    set ucastc_count [diff_count $REG_UCAST_CTRL_OK_LO $device]
    set pause_count [diff_count $REG_PAUSE_LO $device]

    set total [expr {$64b_count + $50b_count + $128b_count \
        + $256b_count + $512b_count + $1024b_count + $1519_count \
        + $oversize_count + $starts_count + $mcastd_count \
        + $bcastd_count + $ucastd_count + $mcastc_count \
        + $bcastc_count + $ucastc_count + $pause_count} ]

    if {$total != 0} {
        puts "Error: RX and TX packet counts do not match."
        return -1
    } else {
        return 0
    }
}


 # ___________________________________________________________________________________
 #
proc check_stats_log {reg_base} {
    global log
    global BASE_STATS
    global REG_FRAGMENTS_LO
    global REG_FRAGMENTS_HI
    global REG_JABBERS_LO
    global REG_JABBERS_HI
    global REG_CRCERR_LO
    global REG_CRCERR_SIZEOK_HI
    global REG_CRCERR_SIZEOK_LO
    global REG_CRCERR_HI
    global REG_MCAST_DATA_ERR_LO
    global REG_MCAST_DATA_ERR_HI
    global REG_BCAST_DATA_ERR_LO
    global REG_BCAST_DATA_ERR_HI
    global REG_UCAST_DATA_ERR_LO
    global REG_UCAST_DATA_ERR_HI
    global REG_MCAST_CTRL_ERR_LO
    global REG_MCAST_CTRL_ERR_HI
    global REG_BCAST_CTRL_ERR_LO
    global REG_BCAST_CTRL_ERR_HI
    global REG_UCAST_CTRL_ERR_LO
    global REG_UCAST_CTRL_ERR_HI
    global REG_PAUSE_ERR_HI
    global REG_PAUSE_ERR_LO
    global REG_64B_LO
    global REG_64B_HI
    global REG_65to127B_LO
    global REG_65to127B_HI
    global REG_128to255B_LO
    global REG_128to255B_HI
    global REG_256to511B_LO
    global REG_256to511B_HI
    global REG_512to1023B_LO
    global REG_512to1023B_HI
    global REG_1024to1518B_LO
    global REG_1024to1518B_HI
    global REG_1519toMAXB_LO
    global REG_1519toMAXB_HI
    global REG_OVERSIZE_LO
    global REG_OVERSIZE_HI
    global REG_MCAST_DATA_OK_LO
    global REG_MCAST_DATA_OK_HI
    global REG_BCAST_DATA_OK_LO
    global REG_BCAST_DATA_OK_HI
    global REG_UCAST_DATA_OK_LO
    global REG_UCAST_DATA_OK_HI
    global REG_MCAST_CTRL_OK_LO
    global REG_MCAST_CTRL_OK_HI
    global REG_BCAST_CTRL_OK_LO
    global REG_BCAST_CTRL_OK_HI
    global REG_UCAST_CTRL_OK_LO
    global REG_UCAST_CTRL_OK_HI
    global REG_PAUSE_LO
    global REG_PAUSE_HI
    global REG_RNT_LO
    global REG_RNT_HI
    global REG_ST_LO
    global REG_ST_HI
    global REG_DB_LO
    global REG_DB_HI
    global REG_EBLK_HI
    global REG_EBLK_LO
    global REG_FST_LO
    global REG_FST_HI
    global REG_F_LONG_HI
    global REG_F_LONG_LO
    global REG_STAT_CFG
    global REG_STAT_STATUS

    set BASE_STATS $reg_base
    #for CLI output only
    #for table widths
    set w_des 30
    set w_val 30
    pause_stats $reg_base
    set msg_hdr_tborder_cli             "==================================================================="
    set msg_hdr_title_cli               "              STATISTICS FOR BASE $BASE_STATS                      "
    set msg_hdr_lborder_cli             "==================================================================="
    set msg_Tx_Title_cli                    [format "| %-*s | %-*s |" $w_des "--DESCRIPTION--" $w_val "--VALUE--"]
    set msg_Tx_Frame_Starts_cli             [format "| %-*s | %-*d |" $w_des "Tx Frame Starts" $w_val                   [expr [stats_read $BASE_STATS     $REG_ST_LO                ]]]
    set msg_Fragmented_Frames_cli           [format "| %-*s | %-*d |" $w_des "Fragmented Frames" $w_val                 [expr [stats_read $BASE_STATS     $REG_FRAGMENTS_LO         ]]]
    set msg_Jabbered_Frames_cli             [format "| %-*s | %-*d |" $w_des "Jabbered Frames" $w_val                   [expr [stats_read $BASE_STATS     $REG_JABBERS_LO           ]]]
    set msg_Any_Size_with_FCS_Err_cli       [format "| %-*s | %-*d |" $w_des "Any Size with FCS Err Frames" $w_val      [expr [stats_read $BASE_STATS     $REG_CRCERR_LO            ]]]
    set msg_Right_Size_with_FCS_Err_cli     [format "| %-*s | %-*d |" $w_des "Right Size with FCS Err Frames" $w_val    [expr [stats_read $BASE_STATS     $REG_CRCERR_SIZEOK_LO     ]]]
    set msg_Multicast_data_Err_Frames_cli   [format "| %-*s | %-*d |" $w_des "Multicast data  Err Frames" $w_val        [expr [stats_read $BASE_STATS     $REG_MCAST_DATA_ERR_LO    ]]]
    set msg_Broadcast_data_Err_Frames_cli   [format "| %-*s | %-*d |" $w_des "Broadcast data Err  Frames" $w_val        [expr [stats_read $BASE_STATS     $REG_BCAST_DATA_ERR_LO    ]]]
    set msg_Unicast_data_Err_Frames_cli     [format "| %-*s | %-*d |" $w_des "Unicast data Err  Frames" $w_val          [expr [stats_read $BASE_STATS     $REG_UCAST_DATA_ERR_LO    ]]]
    set msg_Multicast_ctrl_Err_Frames_cli   [format "| %-*s | %-*d |" $w_des "Multicast control  Err Frames" $w_val     [expr [stats_read $BASE_STATS     $REG_MCAST_CTRL_ERR_LO    ]]]
    set msg_Broadcast_ctrl_Err_Frames_cli   [format "| %-*s | %-*d |" $w_des "Broadcast control Err  Frames" $w_val     [expr [stats_read $BASE_STATS     $REG_BCAST_CTRL_ERR_LO    ]]]
    set msg_Unicast_control_Err_Frames_cli  [format "| %-*s | %-*d |" $w_des "Unicast control Err  Frames" $w_val       [expr [stats_read $BASE_STATS     $REG_UCAST_CTRL_ERR_LO    ]]]
    set msg_Pause_control_Err_Frames_cli    [format "| %-*s | %-*d |" $w_des "Pause control Err  Frames" $w_val         [expr [stats_read $BASE_STATS     $REG_PAUSE_ERR_LO         ]]]


    set msg_64_Byte_Frames_cli              [format "| %-*s | %-*d |" $w_des "64 Byte Frames" $w_val                [expr [stats_read $BASE_STATS     $REG_64B_LO           ]]]
    set msg_65_127_Byte_Frames_cli          [format "| %-*s | %-*d |" $w_des "65 - 127 Byte Frames" $w_val          [expr [stats_read $BASE_STATS     $REG_65to127B_LO      ]]]
    set msg_128_255_Byte_Frames_cli         [format "| %-*s | %-*d |" $w_des "128 - 255 Byte Frames" $w_val         [expr [stats_read $BASE_STATS     $REG_128to255B_LO     ]]]
    set msg_256_511_Byte_Frames_cli         [format "| %-*s | %-*d |" $w_des "256 - 511 Byte Frames" $w_val         [expr [stats_read $BASE_STATS     $REG_256to511B_LO     ]]]
    set msg_512_1023_Byte_Frames_cli        [format "| %-*s | %-*d |" $w_des "512 - 1023 Byte Frames" $w_val        [expr [stats_read $BASE_STATS     $REG_512to1023B_LO    ]]]
    set msg_1024_1518_Byte_Frames_cli       [format "| %-*s | %-*d |" $w_des "1024 - 1518 Byte Frames" $w_val       [expr [stats_read $BASE_STATS     $REG_1024to1518B_LO   ]]]
    set msg_1519_MAX_Byte_Frames_cli        [format "| %-*s | %-*d |" $w_des "1519 - MAX Byte Frames" $w_val        [expr [stats_read $BASE_STATS     $REG_1519toMAXB_LO    ]]]
    set msg_More_than_MAX_Byte_Frames_cli   [format "| %-*s | %-*d |" $w_des "> MAX Byte Frames" $w_val             [expr [stats_read $BASE_STATS     $REG_OVERSIZE_LO      ]]]
    set msg_Multicast_data_OK_Frames_cli    [format "| %-*s | %-*d |" $w_des "Multicast data  OK  Frames" $w_val    [expr [stats_read $BASE_STATS     $REG_MCAST_DATA_OK_LO ]]]
    set msg_Broadcast_data_OK_Frames_cli    [format "| %-*s | %-*d |" $w_des "Broadcast data OK   Frames" $w_val    [expr [stats_read $BASE_STATS     $REG_BCAST_DATA_OK_LO ]]]
    set msg_Unicast_data_OK_Frames_cli      [format "| %-*s | %-*d |" $w_des "Unicast data OK   Frames" $w_val      [expr [stats_read $BASE_STATS     $REG_UCAST_DATA_OK_LO ]]]
    set msg_Multicast_Control_Frames_cli    [format "| %-*s | %-*d |" $w_des "Multicast Control Frames" $w_val      [expr [stats_read $BASE_STATS     $REG_MCAST_CTRL_OK_LO ]]]
    set msg_Broadcast_Control_Frames_cli    [format "| %-*s | %-*d |" $w_des "Broadcast Control Frames" $w_val      [expr [stats_read $BASE_STATS     $REG_BCAST_CTRL_OK_LO ]]]
    set msg_Unicast_Control_Frames_cli      [format "| %-*s | %-*d |" $w_des "Unicast Control Frames" $w_val        [expr [stats_read $BASE_STATS     $REG_UCAST_CTRL_OK_LO ]]]
    set msg_Pause_Control_Frames_cli        [format "| %-*s | %-*d |" $w_des "Pause Control Frames" $w_val          [expr [stats_read $BASE_STATS     $REG_PAUSE_LO         ]]]

    #for log
    set msg_hdr_title_log             "*TX STATISTICS*"
    set msg_Tx_Title_log             "--DESCRIPTION--, --VALUE--"

    set msg_Tx_Frame_Starts_log             "Tx Frame Starts"                   [expr [reg_read $BASE_STATS     $REG_ST_LO              ]]]
    set msg_Fragmented_Frames_log           "Fragmented Frames"                 [expr [reg_read $BASE_STATS     $REG_FRAGMENTS_LO       ]]]
    set msg_Jabbered_Frames_log             "Jabbered Frames"                   [expr [reg_read $BASE_STATS     $REG_JABBERS_LO         ]]]
    set msg_Any_Size_with_FCS_Err_log       "Any Size with FCS Err Frames"      [expr [reg_read $BASE_STATS     $REG_CRCERR_LO          ]]]
    set msg_Right_Size_with_FCS_Err_log     "Right Size with FCS Err Frames"    [expr [reg_read $BASE_STATS     $REG_CRCERR_SIZEOK_LO   ]]]
    set msg_Multicast_data_Err_Frames_log   "Multicast data  Err Frames"        [expr [reg_read $BASE_STATS     $REG_MCAST_DATA_ERR_LO  ]]]
    set msg_Broadcast_data_Err_Frames_log   "Broadcast data Err  Frames"        [expr [reg_read $BASE_STATS     $REG_BCAST_DATA_ERR_LO  ]]]
    set msg_Unicast_data_Err_Frames_log     "Unicast data Err  Frames"          [expr [reg_read $BASE_STATS     $REG_UCAST_DATA_ERR_LO  ]]]
    set msg_Multicast_ctrl_Err_Frames_log   "Multicast control  Err Frames"     [expr [reg_read $BASE_STATS     $REG_MCAST_CTRL_ERR_LO  ]]]
    set msg_Broadcast_ctrl_Err_Frames_log   "Broadcast control Err  Frames"     [expr [reg_read $BASE_STATS     $REG_BCAST_CTRL_ERR_LO  ]]]
    set msg_Unicast_control_Err_Frames_log  "Unicast control Err  Frames"       [expr [reg_read $BASE_STATS     $REG_UCAST_CTRL_ERR_LO  ]]]
    set msg_Pause_control_Err_Frames_log    "Pause control Err  Frames"         [expr [reg_read $BASE_STATS     $REG_PAUSE_ERR_LO       ]]]

    set msg_64_Byte_Frames_log              "64 Byte Frames"                [expr [reg_read $BASE_STATS     $REG_64B_LO             ]]]
    set msg_65_127_Byte_Frames_log          "65 - 127 Byte Frames"          [expr [reg_read $BASE_STATS     $REG_65to127B_LO        ]]]
    set msg_128_255_Byte_Frames_log         "128 - 255 Byte Frames"         [expr [reg_read $BASE_STATS     $REG_128to255B_LO       ]]]
    set msg_256_511_Byte_Frames_log         "256 - 511 Byte Frames"         [expr [reg_read $BASE_STATS     $REG_256to511B_LO       ]]]
    set msg_512_1023_Byte_Frames_log        "512 - 1023 Byte Frames"        [expr [reg_read $BASE_STATS     $REG_512to1023B_LO      ]]]
    set msg_1024_1518_Byte_Frames_log       "1024 - 1518 Byte Frames"       [expr [reg_read $BASE_STATS     $REG_1024to1518B_LO     ]]]
    set msg_1519_MAX_Byte_Frames_log        "1519 - MAX Byte Frames"        [expr [reg_read $BASE_STATS     $REG_1519toMAXB_LO      ]]]
    set msg_More_than_MAX_Byte_Frames_log   "> MAX Byte Frames"             [expr [reg_read $BASE_STATS     $REG_OVERSIZE_LO        ]]]
    set msg_Multicast_data_OK_Frames_log    "Multicast data  OK  Frames"    [expr [reg_read $BASE_STATS     $REG_MCAST_DATA_OK_LO   ]]]
    set msg_Broadcast_data_OK_Frames_log    "Broadcast data OK   Frames"    [expr [reg_read $BASE_STATS     $REG_BCAST_DATA_OK_LO   ]]]
    set msg_Unicast_data_OK_Frames_log      "Unicast data OK   Frames"      [expr [reg_read $BASE_STATS     $REG_UCAST_DATA_OK_LO   ]]]
    set msg_Multicast_Control_Frames_log    "Multicast Control Frames"      [expr [reg_read $BASE_STATS     $REG_MCAST_CTRL_OK_LO   ]]]
    set msg_Broadcast_Control_Frames_log    "Broadcast Control Frames"      [expr [reg_read $BASE_STATS     $REG_BCAST_CTRL_OK_LO   ]]]
    set msg_Unicast_Control_Frames_log      "Unicast Control Frames"        [expr [reg_read $BASE_STATS     $REG_UCAST_CTRL_OK_LO   ]]]
    set msg_Pause_Control_Frames_log        "Pause Control Frames"          [expr [reg_read $BASE_STATS     $REG_PAUSE_LO           ]]]

     # ______________________________________________________________________________________________________________________________
     #
    if {$log == "both"} {puts "$msg_hdr_tborder_cli\r"} elseif {$log == "log"} {} else {puts "$msg_hdr_tborder_cli\r"}
    if {$log == "both"} {putl "$msg_hdr_title_log"; puts "$msg_hdr_title_cli\r"} elseif {$log == "log"} {putl "$msg_hdr_title_log"} else {puts "$msg_hdr_title_cli\r"}
    if {$log == "both"} {puts "$msg_hdr_lborder_cli\r"} elseif {$log == "log"} {} else {puts "$msg_hdr_lborder_cli\r"}
    if {$log == "both"} {putl "$msg_Tx_Title_log"; puts "$msg_Tx_Title_cli\r"} elseif {$log == "log"} {putl "$msg_Tx_Title_log"} else {puts "$msg_Tx_Title_cli\r"}
    
    if {$log == "both"} {putl "$msg_Tx_Frame_Starts_log"; puts "$msg_Tx_Frame_Starts_cli\r"} elseif {$log == "log"} {putl "$msg_Tx_Frame_Starts_log"} else {puts "$msg_Tx_Frame_Starts_cli\r"}
    if {$log == "both"} {putl "$msg_8_byte_data_blocks_log"; puts "$msg_8_byte_data_blocks_cli\r"} elseif {$log == "log"} {putl "$msg_8_byte_data_blocks_log"} else {puts "$msg_8_byte_data_blocks_cli\r"}

    
    if {$log == "both"} {putl "$msg_64_Byte_Frames_log"; puts "$msg_64_Byte_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_64_Byte_Frames_log"} else {puts "$msg_64_Byte_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_65_127_Byte_Frames_log"; puts "$msg_65_127_Byte_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_65_127_Byte_Frames_log"} else {puts "$msg_65_127_Byte_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_128_255_Byte_Frames_log"; puts "$msg_128_255_Byte_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_128_255_Byte_Frames_log"} else {puts "$msg_128_255_Byte_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_256_511_Byte_Frames_log"; puts "$msg_256_511_Byte_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_256_511_Byte_Frames_log"} else {puts "$msg_256_511_Byte_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_512_1023_Byte_Frames_log"; puts "$msg_512_1023_Byte_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_512_1023_Byte_Frames_log"} else {puts "$msg_512_1023_Byte_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_1024_1518_Byte_Frames_log"; puts "$msg_1024_1518_Byte_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_1024_1518_Byte_Frames_log"} else {puts "$msg_1024_1518_Byte_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_1519_MAX_Byte_Frames_log"; puts "$msg_1519_MAX_Byte_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_1519_MAX_Byte_Frames_log"} else {puts "$msg_1519_MAX_Byte_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_More_than_MAX_Byte_Frames_log"; puts "$msg_More_than_MAX_Byte_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_More_than_MAX_Byte_Frames_log"} else {puts "$msg_More_than_MAX_Byte_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_Multicast_data_Err_Frames_log"; puts "$msg_Multicast_data_Err_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_Multicast_data_Err_Frames_log"} else {puts "$msg_Multicast_data_Err_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_Multicast_data_OK_Frames_log"; puts "$msg_Multicast_data_OK_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_Multicast_data_OK_Frames_log"} else {puts "$msg_Multicast_data_OK_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_Broadcast_data_Err_Frames_log"; puts "$msg_Broadcast_data_Err_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_Broadcast_data_Err_Frames_log"} else {puts "$msg_Broadcast_data_Err_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_Broadcast_data_OK_Frames_log"; puts "$msg_Broadcast_data_OK_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_Broadcast_data_OK_Frames_log"} else {puts "$msg_Broadcast_data_OK_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_Unicast_data_Err_Frames_log"; puts "$msg_Unicast_data_Err_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_Unicast_data_Err_Frames_log"} else {puts "$msg_Unicast_data_Err_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_Unicast_data_OK_Frames_log"; puts "$msg_Unicast_data_OK_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_Unicast_data_OK_Frames_log"} else {puts "$msg_Unicast_data_OK_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_Multicast_Control_Frames_log"; puts "$msg_Multicast_Control_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_Multicast_Control_Frames_log"} else {puts "$msg_Multicast_Control_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_Broadcast_Control_Frames_log"; puts "$msg_Broadcast_Control_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_Broadcast_Control_Frames_log"} else {puts "$msg_Broadcast_Control_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_Unicast_Control_Frames_log"; puts "$msg_Unicast_Control_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_Unicast_Control_Frames_log"} else {puts "$msg_Unicast_Control_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_Pause_Control_Frames_log"; puts "$msg_Pause_Control_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_Pause_Control_Frames_log"} else {puts "$msg_Pause_Control_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_Fragmented_Frames_log"; puts "$msg_Fragmented_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_Fragmented_Frames_log"} else {puts "$msg_Fragmented_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_Jabbered_Frames_log"; puts "$msg_Jabbered_Frames_cli\r"} elseif {$log == "log"} {putl "$msg_Jabbered_Frames_log"} else {puts "$msg_Jabbered_Frames_cli\r"}
    if {$log == "both"} {putl "$msg_Right_Size_with_FCS_Err_log\r"; puts "$msg_Right_Size_with_FCS_Err_cli\n"} elseif {$log == "log"} {putl "$msg_Right_Size_with_FCS_Err_log\r"} else {puts "$msg_Right_Size_with_FCS_Err_cli\n"} 
    unpause_stats $reg_base
}



 # ___________________________________________________________________________________
 # For internal debug purpose -- start 


proc check_stats_internal {reg_base t} {
    global BASE_STATS
    global REG_FRAGMENTS_LO
    global REG_FRAGMENTS_HI
    global REG_JABBERS_LO
    global REG_JABBERS_HI
    global REG_CRCERR_LO
    global REG_CRCERR_SIZEOK_HI
    global REG_CRCERR_SIZEOK_LO
    global REG_CRCERR_HI
    global REG_MCAST_DATA_ERR_LO
    global REG_MCAST_DATA_ERR_HI
    global REG_BCAST_DATA_ERR_LO
    global REG_BCAST_DATA_ERR_HI
    global REG_UCAST_DATA_ERR_LO
    global REG_UCAST_DATA_ERR_HI
    global REG_MCAST_CTRL_ERR_LO
    global REG_MCAST_CTRL_ERR_HI
    global REG_BCAST_CTRL_ERR_LO
    global REG_BCAST_CTRL_ERR_HI
    global REG_UCAST_CTRL_ERR_LO
    global REG_UCAST_CTRL_ERR_HI
    global REG_PAUSE_ERR_HI
    global REG_PAUSE_ERR_LO
    global REG_64B_LO
    global REG_64B_HI
    global REG_65to127B_LO
    global REG_65to127B_HI
    global REG_128to255B_LO
    global REG_128to255B_HI
    global REG_256to511B_LO
    global REG_256to511B_HI
    global REG_512to1023B_LO
    global REG_512to1023B_HI
    global REG_1024to1518B_LO
    global REG_1024to1518B_HI
    global REG_1519toMAXB_LO
    global REG_1519toMAXB_HI
    global REG_OVERSIZE_LO
    global REG_OVERSIZE_HI
    global REG_MCAST_DATA_OK_LO
    global REG_MCAST_DATA_OK_HI
    global REG_BCAST_DATA_OK_LO
    global REG_BCAST_DATA_OK_HI
    global REG_UCAST_DATA_OK_LO
    global REG_UCAST_DATA_OK_HI
    global REG_MCAST_CTRL_OK_LO
    global REG_MCAST_CTRL_OK_HI
    global REG_BCAST_CTRL_OK_LO
    global REG_BCAST_CTRL_OK_HI
    global REG_UCAST_CTRL_OK_LO
    global REG_UCAST_CTRL_OK_HI
    global REG_PAUSE_LO
    global REG_PAUSE_HI
    global REG_RNT_LO
    global REG_RNT_HI
    global REG_ST_LO
    global REG_ST_HI
    global REG_DB_LO
    global REG_DB_HI
    global REG_EBLK_HI
    global REG_EBLK_LO
    global REG_FST_LO
    global REG_FST_HI
    global REG_F_LONG_HI
    global REG_F_LONG_LO
    global REG_STAT_CFG
    global REG_STAT_STATUS

    set BASE_STATS $reg_base
    #for CLI output only
    #for table widths
    set w_des 30
    set w_val 30
    pause_stats $reg_base
    puts " =========================================================================================="
    puts "                        STATISTICS FOR BASE $BASE_STATS ($t)                               "
    puts " =========================================================================================="
    puts "Fragmented Frames                : [expr [stats_read $BASE_STATS     $REG_FRAGMENTS_LO        ]] "
    puts "Jabbered Frames                  : [expr [stats_read $BASE_STATS     $REG_JABBERS_LO          ]] "
    puts "Any Size with FCS Err Frame      : [expr [stats_read $BASE_STATS     $REG_CRCERR_LO           ]] "
    puts "Right Size with FCS Err Fra      : [expr [stats_read $BASE_STATS     $REG_CRCERR_SIZEOK_LO    ]] "
    puts "Multicast data  Err Frames       : [expr [stats_read $BASE_STATS     $REG_MCAST_DATA_ERR_LO   ]] "
    puts "Broadcast data Err  Frames       : [expr [stats_read $BASE_STATS     $REG_BCAST_DATA_ERR_LO   ]] "
    puts "Unicast data Err  Frames         : [expr [stats_read $BASE_STATS     $REG_UCAST_DATA_ERR_LO   ]] "
    puts "Multicast control  Err Frame     : [expr [stats_read $BASE_STATS     $REG_MCAST_CTRL_ERR_LO   ]] "
    puts "Broadcast control Err  Frame     : [expr [stats_read $BASE_STATS     $REG_BCAST_CTRL_ERR_LO   ]] "
    puts "Unicast control Err  Frames      : [expr [stats_read $BASE_STATS     $REG_UCAST_CTRL_ERR_LO   ]] "
    puts "Pause control Err  Frames        : [expr [stats_read $BASE_STATS     $REG_PAUSE_ERR_LO        ]] "
    puts "Fragmented Frames -NO CRC        : [expr [stats_read $BASE_STATS     $REG_RNT_LO        ]] "
    puts "Invalid SOP Err  Frames          : [expr [stats_read $BASE_STATS     $REG_ST_LO        ]] "
    puts "Invalid EOP Err  Frames          : [expr [stats_read $BASE_STATS     $REG_DB_LO        ]] "


    puts "64 Byte Frames                   : [expr [stats_read $BASE_STATS     $REG_64B_LO              ]] "
    puts "65 - 127 Byte Frames             : [expr [stats_read $BASE_STATS     $REG_65to127B_LO         ]] "
    puts "128 - 255 Byte Frames            : [expr [stats_read $BASE_STATS     $REG_128to255B_LO        ]] "
    puts "256 - 511 Byte Frames            : [expr [stats_read $BASE_STATS     $REG_256to511B_LO        ]] "
    puts "512 - 1023 Byte Frames           : [expr [stats_read $BASE_STATS     $REG_512to1023B_LO       ]] "
    puts "1024 - 1518 Byte Frames          : [expr [stats_read $BASE_STATS     $REG_1024to1518B_LO      ]] "
    puts "1519 - MAX Byte Frames           : [expr [stats_read $BASE_STATS     $REG_1519toMAXB_LO       ]] "
    puts "> MAX Byte Frames                : [expr [stats_read $BASE_STATS     $REG_OVERSIZE_LO         ]] "
    puts "$t Frame Starts                  : [expr [stats_read $BASE_STATS     $REG_ST_LO               ]] "
    puts "Multicast data  OK  Frame        : [expr [stats_read $BASE_STATS     $REG_MCAST_DATA_OK_LO    ]] "
    puts "Broadcast data OK   Frame        : [expr [stats_read $BASE_STATS     $REG_BCAST_DATA_OK_LO    ]] "
    puts "Unicast data OK   Frames         : [expr [stats_read $BASE_STATS     $REG_UCAST_DATA_OK_LO    ]] "
    puts "Multicast Control Frames         : [expr [stats_read $BASE_STATS     $REG_MCAST_CTRL_OK_LO    ]] "
    puts "Broadcast Control Frames         : [expr [stats_read $BASE_STATS     $REG_BCAST_CTRL_OK_LO    ]] "
    puts "Unicast Control Frames           : [expr [stats_read $BASE_STATS     $REG_UCAST_CTRL_OK_LO    ]] "
    puts "Pause Control Frames             : [expr [stats_read $BASE_STATS     $REG_PAUSE_LO            ]] "
    unpause_stats $reg_base
}

proc CHK_TXSTATS_INTERNAL {} {
    global BASE_TXSTATS
    check_stats_internal $BASE_TXSTATS Tx
}

proc CHK_RXSTATS_INTERNAL {} {
    global BASE_RXSTATS
    check_stats_internal $BASE_RXSTATS Rx
}

proc chkmac_stats_internal {} {
    CHK_RXSTATS_INTERNAL
    CHK_TXSTATS_INTERNAL
}

 # ___________________________________________________________________________________
 # For internal debug purpose -- end 

